﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Text.RegularExpressions;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			rpg.AutoGeneratingPropertyDefinition += new EventHandler<Telerik.Windows.Controls.Data.PropertyGrid.AutoGeneratingPropertyDefinitionEventArgs>(rpg_AutoGeneratingPropertyDefinition);
			rpg.Item = new MyTestClass() { StringProp = "91das", IntProp = 10, DateTimeProp = new DateTime(1920, 2, 21) };
		}

		void rpg_AutoGeneratingPropertyDefinition(object sender, Telerik.Windows.Controls.Data.PropertyGrid.AutoGeneratingPropertyDefinitionEventArgs e)
		{
			(e.PropertyDefinition.Binding as Binding).ValidatesOnDataErrors = true;
			(e.PropertyDefinition.Binding as Binding).NotifyOnValidationError = true;
		}

		private ObservableCollection<ValidationError> results;

		public ObservableCollection<ValidationError> Results
		{
			get
			{
				if (this.results == null)
				{
					this.results = new ObservableCollection<ValidationError>();
				}
				return results;
			}
		}
	}

	public class MyTestClass : IDataErrorInfo, INotifyPropertyChanged
	{
		private int intVar;

		public int IntProp
		{
			get { return intVar; }
			set
			{
				intVar = value;
				this.OnPropertyChanged("IntProp");
			}
		}

		private string stringVar;

		public string StringProp
		{
			get { return stringVar; }
			set
			{
				stringVar = value;
				this.OnPropertyChanged("StringProp");
			}
		}

		private DateTime dateTimeVar;

		public DateTime DateTimeProp
		{
			get { return dateTimeVar; }
			set
			{
				dateTimeVar = value;
				this.OnPropertyChanged("DateTimeProp");
			}
		}

		[Browsable(false)]
		public string Error
		{
			get { return string.Empty; }
		}

		public string this[string columnName]
		{
			get
			{
				if (columnName == "IntProp")
				{
					return this.IntProp < 100 && this.IntProp > 0 ? string.Empty : "Value should be in the range of (0, 100)";
				}
				if (columnName == "StringProp")
				{
					return this.StringProp != null && Regex.IsMatch(this.StringProp, @"^[0-9]+[\p{L}]*") ? string.Empty : @"Value should math the regex: ^[0-9]+[\p{L}]*";
				}
				if (columnName == "DateTimeProp")
				{
					return this.DateTimeProp.Year > 1900 ? string.Empty : "Date should be after 1/1/1900";
				}
				return string.Empty;
			}
		}

		protected void OnPropertyChanged(string name)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(name));
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;
	}
}
